#!/bin/sh
# Copyright 1991 Digital Equipment Corporation.
# All rights reserved. See copyright notice in attached file COPYRIGHT.
# Last modified on Mon Feb 18 15:47:09 1991 by burrows

usage="usage: makenewsindex [-c]"

lib=/usr/lib/nilib

compress=
while
	case "$1" in
	-c)	compress="$1";;
	"")	break;;
	*)	echo "$usage" >&2; exit 2;;
	esac
do
	shift
done

if [ -f current/noupdate ]; then exit 0; fi

swap=

if true
then
	rm -fr tmp new old || exit 2

	if [ -f current/redo ]
	then
		current=tmp
		mkdir tmp || exit 2
		current/redo > tmp/groups || exit 2
		cp /dev/null tmp/messages || exit 2
		cp /dev/null tmp/index || exit 2
		cp /dev/null tmp/index.i || exit 2
		cp /dev/null tmp/index.recent || exit 2
		cp /dev/null tmp/index.recent.i || exit 2
		cp /dev/null tmp/summary || exit 2
		cp /dev/null tmp/summary.recent || exit 2
		cp /dev/null tmp/dates || exit 2
		cp /dev/null tmp/dates.recent || exit 2
		cp /dev/null tmp/delete || exit 2
		if [ -f current/update ]
		then
			cp /dev/null tmp/update || exit 2
		fi
	else
		current=current
	fi

	mkdir new || exit 2
	cp /dev/null new/timestamp || exit 2

	if [ -f $current/update ]
	then
		flag=-a
		cp /dev/null new/update || exit 2
	else
		flag=
	fi

	$lib/scannews $flag $current/groups new/groups \
		$current/messages new/messages \
		new/extradelete $current/timestamp > new/unseen || exit 2

	ln $current/delete $current/index.recent $current/summary.recent \
		$current/dates.recent $current/index.recent.i new || exit 2
	if [ -s new/unseen ]
	then
		split -3000 new/unseen new/unseen. || exit 2
		cat new/unseen.* | cmp - new/unseen || exit 2
		rm new/unseen || exit 2

		for x in new/unseen.*
		do
			(cd /usr/spool/news; $lib/maketextindex -i -U) < $x \
				> new/extra ||
			(cd /usr/spool/news; $lib/maketextindex -i -U) < $x \
				> new/extra || exit 2

			prefix=new/extra.0
			if [ -f $prefix.0 ]
			then
				level=0
				files=
				while [ -f $prefix.$level ]
				do
					files="$files $prefix.$level"
					level=`expr $level + 1`
				done

				$lib/msgmerge $files new/extra \
					> $prefix.$level || exit 2
				rm $files || exit 2
			else
				mv new/extra $prefix.0 || exit 2
			fi

			(cd /usr/spool/news; $lib/precis) < $x > new/extra ||
			(cd /usr/spool/news; $lib/precis) < $x > new/extra ||
				exit 2

			prefix=new/extra.1
			if [ -f $prefix.0 ]
			then
				level=0
				files=
				while [ -f $prefix.$level ]
				do
					files="$files $prefix.$level"
					level=`expr $level + 1`
				done

				$lib/precismerge $files new/extra \
					> $prefix.$level || exit 2
				rm $files || exit 2
			else
				mv new/extra $prefix.0 || exit 2
			fi
		done
		$lib/msgmerge new/index.recent new/extra.0.* > new/next ||
				exit 2
		mv new/next new/index.recent || exit 2

		$lib/precismerge new/summary.recent new/extra.1.* > new/next ||
				exit 2
		mv new/next new/summary.recent || exit 2

		rm -f new/extra new/extra.?.*

		$lib/mkdates < new/summary.recent > new/next || exit 2
		mv new/next new/dates.recent || exit 2
		$lib/mksubindex < new/index.recent > new/next || exit 2
		mv new/next new/index.recent.i || exit 2
		swap=1
	fi

	if [ -s new/extradelete ]
	then
		cat new/delete new/extradelete > new/next || exit 2
		cat new/delete new/extradelete | cmp - new/next || exit 2
		mv new/next new/delete || exit 2
		rm new/extradelete || exit 2
		swap=1
	fi

	bigsummary=`find new/summary.recent -size +5000 -print`
	case "$bigsummary" in
	new/summary.recent) compress=1;;
	esac

	case "$compress" in
	?*)	if [ -s $current/index ]
		then
		    $lib/msgmerge $current/index new/index.recent \
			> new/extra || exit 2
		else
			ln new/index.recent new/extra || exit 2
		fi
		rm new/index.recent new/index.recent.i || exit 2
		if [ -s new/delete ]
		then
			$lib/msgdelete new/delete < new/extra > new/next ||
				exit 2
			rm new/extra || exit 2
			mv new/next new/index || exit 2
		else
			mv new/extra new/index || exit 2
		fi
		cp /dev/null new/index.recent || exit 2
		cp /dev/null new/index.recent.i || exit 2
		$lib/mksubindex < new/index > new/index.i || exit 2

		if [ -s $current/summary ]
		then
			$lib/precismerge $current/summary new/summary.recent \
				> new/extra || exit 2
		else
			ln new/summary.recent new/extra || exit 2
		fi
		rm new/summary.recent new/dates.recent || exit 2
		if [ -s new/delete ]
		then
			$lib/precisdelete new/delete < new/extra > new/next ||
				exit 2
			rm new/extra || exit 2
			mv new/next new/summary || exit 2
		else
			mv new/extra new/summary || exit 2
		fi
		$lib/mkdates < new/summary > new/next || exit 2
		mv new/next new/dates || exit 2
		cp /dev/null new/summary.recent || exit 2
		cp /dev/null new/dates.recent || exit 2
		if [ -s new/delete ]
		then
			$lib/arraydelete new/delete < new/messages > new/next ||
				exit 2
			mv new/next new/messages || exit 2
		fi
		rm new/delete || exit 2
		cp /dev/null new/delete || exit 2
		swap=1;;
	*)	ln $current/index $current/summary $current/index.i \
			$current/dates new || exit 2;;
	esac
	
	case "$swap" in
	1)	rm -f new/extra new/next new/extradelete \
			new/unseen new/unseen.*

		sync
		[ -d . ] || exit 2
		mv current old || exit 2
		if mv new current
		then
			: nothing
		else
			mv old current
			exit 2
		fi;;
	*)	rm -fr new;;
	esac

	exit 0
fi >&2
