/* Copyright 1991 Digital Equipment Corporation.               */
/* All rights reserved. See copyright notice in attached file COPYRIGHT. */
/* Last modified on Sun Mar 10 16:31:17 1991 by burrows        */

#include <stdio.h>

extern void exit ();
extern void perror ();

#define SUBINDEX	2048

main ()
{
	char buf[2000];
	register int c;
	register char *s;
	register long n, ln;
	register long count = 0;
	long lcount, pcount = -SUBINDEX-1;
	int shift;

	ln = 0;

	c = getchar ();

	while ((c & 0xc0) == 0x80) {
		lcount = count;
		c &= 0x3f;
		s = &buf[c];

		c = getchar ();
		count++;
		
		while (c != '\0' && c != EOF) {
			*s++ = c;
			c = getchar ();
			count++;
		}

		if (c != EOF) {
			c = getchar ();
			count++;
		}

		*s = '\0';
		if (lcount > pcount+SUBINDEX)
			(void) printf ("%s %ld\n", buf, pcount = lcount);

		ln = 0;

		while ((c & 0xc0) != 0x80 && c != EOF) { 
			n = 0;
			shift = 0;
			while ((c & 0xc0) == 0xc0 && c != EOF) {
				n |= (c & 0x3f) << shift;
				shift += 6;
				c = getchar ();
				count++;
			}
			n |= (c & 0x7f) << shift;
			n += ln;
			ln = n;
			c = getchar ();
			count++;
		}
	}
	(void) fflush (stdout);

	if (ferror (stdout)) {
		perror ("mksubindex: stdout");
		exit (2);
	}
	if (ferror (stdin)) {
		perror ("mksubindex: stdin");
		exit (2);
	}

	exit (0);
}
